问一个无向图中去掉任意两点后剩下的连通分量的个数最大值

枚举第一个删去的点,在剩下的子图中求割点

注意,剩下的子图可能不连通,那么就要对每个连通块求割点

计算删去一个点后剩余连通分量个数 left 的方法为:tarjan算法中的时间戳数组dfn[]若为0说明是新的连通分量

求删去割点后剩余连通分量个数:

tarjan算法中将判断是否为割点的bool 数组改为int类型,并将iscut[i] = 1 改为 iscut[i]++ 即可

那么对于非根节点,删去后剩余个数为iscut[i] + 1(子树个数加上父节点),根节点为iscut[i] (没有父节点)

那么全题答案便是 max(iscut[i] + 1) + left - 1

细节见代码

#pragma comment(linker, "/STACK:102400000000,102400000000")
#include <cstdio>
#include <ctime>
#include <cstdlib>
#include <cstring>
#include <queue>
#include <string>
#include <set>
#include <stack>
#include <map>
#include <cmath>
#include <vector>
#include <iostream>
#include <algorithm>
#include <bitset>
using namespace std;
//LOOP
#define FD(i, b, a) for(int i = (b) - 1; i >= (a); --i)
#define FE(i, a, b) for(int i = (a); i <= (b); ++i)
#define FED(i, b, a) for(int i = (b); i>= (a); --i)
#define REP(i, N) for(int i = 0; i < (N); ++i)
#define CLR(A,value) memset(A,value,sizeof(A))
//OTHER
#define PB push_back
//INPUT
#define RI(n) scanf("%d", &n)
#define RII(n, m) scanf("%d%d", &n, &m)
#define RIII(n, m, k) scanf("%d%d%d", &n, &m, &k)
#define RIV(n, m, k, p) scanf("%d%d%d%d", &n, &m, &k, &p)
#define RS(s) scanf("%s", s)
typedef long long LL;
typedef unsigned long long ULL;
const int INF = 1000000000;
const int MAXN = 5050;
const int MOD = 1000000; vector<int> G[MAXN];
int dfn[MAXN], low[MAXN], iscut[MAXN]; //时间戳数组,所能访问的最早祖先,删去此点后所能得到的连通分量个数
int dfs_c, ans;
int n, m, none; void add(int u, int v)
{
G[u].push_back(v);
G[v].push_back(u);
} int tarjan(int u, int fa)
{
bool f = false; ///判断重边用
int lowu = dfn[u] = ++dfs_c;
int child = 0, sz = G[u].size();
REP(i, sz)
{
int v = G[u][i];
if (v == none) continue; ///若为枚举的第一个删除的节点,忽略
if (v == fa && !f)
{
f = 1;
continue;
}
if (!dfn[v])
{
int lowv = tarjan(v, u);
lowu = min(lowu, lowv);
if (lowv >= dfn[u])
iscut[u]++;
}
else
lowu = min(lowu, dfn[v]);
}
if (fa < 0 && child == 1) ///若为此连通分量的根节点且只有一个子树,那么删去后连通分量为 1
iscut[u] = 1;
low[u] = lowu;
return lowu;
} void init()
{
REP(i, n + 1)
G[i].clear();
ans = 0;
} int solve(int x)
{
int ret = 0;
none = x;
CLR(dfn, 0), CLR(low, 0);
CLR(iscut, 0);
dfs_c = 0;
int left = 0;
REP(i, n)
if (i != x && !dfn[i])
iscut[i]--, left++, tarjan(i, -1); ///dfn为0 说明是根节点,先-1,后面统计时便全是iscut + 1
REP(i, n)
if (i != x)
ret = max(ret, iscut[i] + 1);
ret += left - 1; ///剩下连通分量加上最大iscut值
return ret;
} int main()
{
int x, y;
while (~RII(n, m))
{
init();
REP(i, m)
{
RII(x, y);
add(x, y);
}
REP(i, n)
ans = max(ans, solve(i));
printf("%d\n", ans);
}
}
/* 5 5
0 3
3 4
3 2
1 2
2 4
*/

hdu4587 TWO NODES的更多相关文章

  1. hdu4587 Two Nodes 求图中删除两个结点剩余的连通分量的数量

    题目链接:http://acm.hdu.edu.cn/showproblem.php?pid=4587 题目给了12000ms,对于tarjan这种O(|V|+|E|)复杂度的算法来说,暴力是能狗住的 ...

  2. 备战noip week8

    POJ1144 网络 description: 给出一张\(N\)个点的无向图,求其中割点的个数 data range: \(N\le 100\) solution: 一道模板题(但是读入实在是把我恶 ...

  3. [LeetCode] Count Complete Tree Nodes 求完全二叉树的节点个数

    Given a complete binary tree, count the number of nodes. Definition of a complete binary tree from W ...

  4. [LeetCode] Reverse Nodes in k-Group 每k个一组翻转链表

    Given a linked list, reverse the nodes of a linked list k at a time and return its modified list. If ...

  5. [LeetCode] Swap Nodes in Pairs 成对交换节点

    Given a linked list, swap every two adjacent nodes and return its head. For example,Given 1->2-&g ...

  6. Swap Nodes in Pairs

    Given a linked list, swap every two adjacent nodes and return its head. For example, Given 1->2-& ...

  7. Leetcode-24 Swap Nodes in Pairs

    #24. Swap Nodes in Pairs Given a linked list, swap every two adjacent nodes and return its head. For ...

  8. No.025:Reverse Nodes in k-Group

    问题: Given a linked list, reverse the nodes of a linked list k at a time and return its modified list ...

  9. No.024:Swap Nodes in Pairs

    问题: Given a linked list, swap every two adjacent nodes and return its head. For example, Given 1-> ...

随机推荐

  1. Hadoop中文编码乱码相关问题

    mapreduce程序处理GBK编码数据并输出GBK编码数据, hadoop涉及输出文本的默认输出编码统一用没有BOM的UTF-8的形式,但是对于中文的输出window系统默认的是GBK,有些格式文件 ...

  2. [BZOJ4004][JLOI2015]装备购买(贪心+线性基)

    求最小权极大线性无关组. 先将所有向量按权值排序,从小到大依次判断,若能被前面已选向量线性表出则不选,这样一定最优. 据说是用拟阵来证明,但感性理解一下感觉比较显然,首先这样个数一定是最多的,其次对于 ...

  3. 【欧拉回路】【欧拉路径】【Fleury算法】CDOJ1634 记得小苹初见,两重心字罗衣

    Fleury算法看这里 http://hihocoder.com/problemset/problem/1181 把每个点看成边,每个横纵坐标看成一个点,得到一个无向图. 如果新图中每个点的度都是偶数 ...

  4. 【tarjan+缩点】BZOJ1051-受欢迎的牛

    [题意] 每一头牛的愿望就是变成一头最受欢迎的牛.现在有N头牛,给你M对整数(A,B),表示牛A认为牛B受欢迎. 这种关系是具有传递性的,如果A认为B受欢迎,B认为C受欢迎,那么牛A也认为牛C受欢迎. ...

  5. [LOJ500]ZQC的拼图

    题目大意: 给你一个m*m的格子,让你往里面放给定的直角三角形,直角顶点必须放在右上角且不能翻转,但是可以把所有给定的三角形放大一个整数倍k,问至少放大几倍能使格子的左下角和右上角连起来?(可以超出边 ...

  6. JDK源码学习笔记——Integer

    一.类定义 public final class Integer extends Number implements Comparable<Integer> 二.属性 private fi ...

  7. HDU 5294 Tricks Device 网络流 最短路

    Tricks Device 题目连接: http://acm.hdu.edu.cn/showproblem.php?pid=5294 Description Innocent Wu follows D ...

  8. python一个简单的爬虫测试

    之前稍微学了一点python,后来一直都没用,今天稍微做一个小爬虫试一试.. 参考了: http://www.cnblogs.com/fnng/p/3576154.html 太久没用了,都忘记pych ...

  9. iOS笔记 基于MKNetworkKit的断点续传

    http://iiiyu.com/2012/07/07/learning-ios-notes-eight/

  10. location和history

    <!DOCTYPE html> <html> <head> <meta charset="UTF-8"> <title> ...